import javax.swing.*;
import java.awt.*;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;
import java.util.Random;

public class FormWarship extends JDialog {
    private DrawingWarship _warship;
     DrawingWarship selectedWarship;
    public DrawingWarship getSelectedCar(){
        return selectedWarship;
    }
    public boolean DialogResult = false;
    private JPanel mainPanel;
    private JPanel drawPanel;
    private JButton buttonCreate;
    private JButton buttonLeft;
    private JButton buttonUp;
    private JButton buttonDown;
    private JButton buttonRight;
    private JToolBar toolBar;
    private JLabel toolBarLabelSpeed;
    private JLabel toolBarLabelWieght;
    private JLabel toolBarLabelColor;
    private JButton buttonCreateModif;
    private JButton buttonSelect;

    public FormWarship(){
        InitializeComponent();
    }

    public FormWarship(DrawingObjectWarship warship){
        InitializeComponent();
        _warship = warship.GetWarship();
        SetData();
    }


    private void Draw(){
        Graphics2D graphics = (Graphics2D) drawPanel.getGraphics();
        graphics.clearRect(0, 0, drawPanel.getWidth(), drawPanel.getHeight());
        drawPanel.paintComponents(graphics);
        _warship.DrawTransport(graphics);
    }

    @Override
    public void paint(Graphics g) {
        super.paint(g);

        if (_warship != null) {
            mainPanel.paintComponents(mainPanel.getGraphics());
            _warship.DrawTransport(g);
        }
    }

    private void SetData(){
        Random rnd = new Random();
        _warship.SetPosition(rnd.nextInt(10, 100), rnd.nextInt(10, 100), mainPanel.getWidth(), mainPanel.getHeight());
        toolBarLabelSpeed.setText("Color: " + _warship.GetWarship().GetSpeed() + "  ");
        toolBarLabelWieght.setText("Weight: " + _warship.GetWarship().GetWeight() + "  ");
        toolBarLabelColor.setText("Color: " + _warship.GetWarship().GetBodyColor().getRed() + " " +
                _warship.GetWarship().GetBodyColor().getGreen() + " " + _warship.GetWarship().GetBodyColor().getBlue());
    }

    private void resizeWindow() {
        _warship.ChangeBorders(drawPanel.getWidth(), drawPanel.getHeight());
        Draw();
    }

    private void InitializeComponent() {
        setContentPane(mainPanel);
        setTitle("Warship");
        setSize(900, 700);
        setVisible(true);

        Icon iconUp = new ImageIcon("src\\Images\\ArrowUp.jpg");
        buttonUp.setIcon(iconUp);
        Icon iconDown = new ImageIcon("src\\Images\\ArrowDown.jpg");
        buttonDown.setIcon(iconDown);
        Icon iconLeft = new ImageIcon("src\\Images\\ArrowLeft.jpg");
        buttonLeft.setIcon(iconLeft);
        Icon iconRight = new ImageIcon("src\\Images\\ArrowRight.jpg");
        buttonRight.setIcon(iconRight);

        //кнопка добавления объекта
        buttonCreate.addActionListener(e -> {
            Random rnd = new Random();
            _warship = new DrawingWarship(rnd.nextInt(100, 300), rnd.nextInt(1000, 2000),
                    new Color(rnd.nextInt(256), rnd.nextInt(256), rnd.nextInt(256)), rnd.nextInt(3));
            SetData();
            Draw();
        });

        //добавление модифицированного объекта
        buttonCreateModif.addActionListener(e -> {
            Random rnd = new Random();
            _warship = new DrawingAircraftCarrier(rnd.nextInt(100, 300), rnd.nextInt(1000, 2000),
                    new Color(rnd.nextInt(256), rnd.nextInt(256), rnd.nextInt(256)),
                    new Color(rnd.nextInt(256), rnd.nextInt(256), rnd.nextInt(256)),
                    rnd.nextBoolean(), rnd.nextBoolean(), rnd.nextBoolean());
            SetData();
            Draw();
        });

        buttonSelect.addActionListener(e -> {
            if(_warship != null){
                selectedWarship =_warship;
                DialogResult = true;
            }
        });

        buttonLeft.addActionListener(e -> {
            if (_warship != null) _warship.MoveTransport(Direction.Left);
            Draw();
        });

        buttonRight.addActionListener(e -> {
            if (_warship != null) _warship.MoveTransport(Direction.Right);
            Draw();
        });

        buttonUp.addActionListener(e -> {
            if (_warship != null) _warship.MoveTransport(Direction.Up);
            Draw();
        });

        buttonDown.addActionListener(e -> {
            if (_warship != null) _warship.MoveTransport(Direction.Down);
            Draw();
        });

        mainPanel.addComponentListener(new ComponentAdapter() {
            @Override
            public void componentResized(ComponentEvent e) {
                super.componentResized(e);
                resizeWindow();
            }
        });
    }
}
