import java.util.ArrayList;
import java.util.HashMap;

public class MapsCollection {
    private final HashMap<String, MapWithSetWarshipsGeneric<DrawingObjectWarship, AbstractMap>> _mapStorages;
    public ArrayList<String> Keys() {
        return new ArrayList<>(_mapStorages.keySet());
    }
    private final int _pictureWidth;
    private final int _pictureHeight;

    public MapsCollection(int pictureWidth, int pictureHeight)
    {
        _mapStorages = new HashMap<>();
        _pictureWidth = pictureWidth;
        _pictureHeight = pictureHeight;
    }

    public void AddMap(String name, AbstractMap map)
    {
        if (_mapStorages.containsKey(name))
        {
            return;
        }
        _mapStorages.put(name, new MapWithSetWarshipsGeneric<>(_pictureWidth,_pictureHeight,map));
    }

    public void DelMap(String name)
    {
        _mapStorages.remove(name);
    }

    public MapWithSetWarshipsGeneric<DrawingObjectWarship, AbstractMap> get(String ind){
        if (_mapStorages.containsKey(ind))
        {
            return _mapStorages.get(ind);
        }
        return null;
    }

    public DrawingObjectWarship Get(String name, int ind) {
        if (_mapStorages.containsKey(name))
        {
            return _mapStorages.get(name).GetWarshipInList(ind);
        }
        return null;
    }
}
