import java.util.ArrayList;
import java.util.Iterator;

public class SetWarshipsGeneric<T extends Object> implements  Iterable<T>{
    private ArrayList<T> _places;
    public int getCount() {
        return _places.size();
    }
    private final int _maxCount;

    public SetWarshipsGeneric(int count)
    {
        _places = new ArrayList<>();
        _maxCount = count;
    }

    public int Insert(T warship)
    {
        return Insert(warship,0);
    }

    public int Insert(T warship, int position)
    {
        if (position < 0 || position >= _maxCount)
            return -1;
        _places.add(position, warship);
        return position;
    }

    public T Remove(int position)
    {
        if (position >= _maxCount || position < 0)
            return null;
        T deleted = _places.get(position);
        _places.remove(position);
        return deleted;
    }

    public T Get(int position)
    {
        if (position > getCount() || position < 0)
            return null;
        return  _places.get(position);
    }

    @Override
    public Iterator<T> iterator() {
        return _places.iterator();
    }
}
