import java.util.ArrayList;
import java.util.Random;

public class WarshipCreatorGeneric <T extends EntityWarship, U extends IDrawingObjectBlock>{
    private final ArrayList<T> Warships;
    private final ArrayList<U> Blocks;
    private int WarshipsCount = 0;
    private int BlocksCount = 0;
    public WarshipCreatorGeneric(int warshipsCount, int blocksCount){
        Warships = new ArrayList<>(warshipsCount);
        Blocks = new ArrayList<>(blocksCount);
    }

    public int AddWarship(T warship){
        if(WarshipsCount <= Warships.size()){
            Warships.add(warship);
            WarshipsCount++;
            return WarshipsCount - 1;
        }
        return -1;
    }

    public int AddBlock(U block){
        if(BlocksCount <= Blocks.size()){
            Blocks.add(block);
            BlocksCount++;
            return BlocksCount - 1;
        }
        return -1;
    }

    public DrawingWarship NewWarshipCreating()
    {
        Random rand=new Random();
        T warship = (T)Warships.get(rand.nextInt(WarshipsCount));
        U block = (U)Blocks.get(rand.nextInt(BlocksCount));

        if(warship instanceof EntityAircraftCarrier){
            return new DrawingAircraftCarrier(warship, block);
        }
        return new DrawingWarship(warship,block);
    }
}
